class Hiscore
	{
	private:
		struct Entry
			{
			int id;
			char *nick;
			int kills;
			int time;
			};

		int rows, cols, entries;							// Ilosc wpisow i max dlugosc wpisu (pomijajac wynik)
		Entry *db;				// Wpisy z wynikami
		//char **table;			// tablica charow

		static int qcompKill(const void *itm1, const void *itm2);
		static int qcompTime(const void *itm1, const void *itm2);

	public:
		Hiscore(int rows=10, int cols=64):
			rows(rows), cols(cols), entries(0), db(NULL), type(0) {};			//, table(NULL) {table=new char*[rows]; for(int i=0; i<rows; i++) table[i]=new char[cols+1];};

		void load(const char *file);
		void clear();

		void sortKill();
		void sortTime();
		inline int getCount() {return entries;};
		inline int getMaxRows() {return rows;};
		inline Entry *getHi(int num) {if(num<entries) return &db[num]; else return NULL;};			// Zwraca wynik

		bool type;
	};
