#include "main.h"

Mucha::~Mucha()
	{
	updateRect(x-anim->spotx, y-anim->spoty, anim->w, anim->h);
	}

void Mucha::move()
	{
	if(anim==NULL)
		{
		printf("FAIL: Mucha.move: Null Anim\n");
		return;
		}
	updateRect(floor(x)-anim->spotx, floor(y)-anim->spoty, anim->w, anim->h);
	if(hp<=0)
		{
		vectors.y+=0.2;
		ang+=vectors.y*3.14/180/2;
		if(vectors.x>1)
			vectors.x-=0.5;
		else if(vectors.x<-1)
			vectors.x+=0.5;
		else
			vectors.x=0;
		}
	else if(dizzy)
		{
		vectors.y+=0.2;
		ang+=vectors.y*3.14/180/2;
		if(dizzyTimer--<=0)
			setUnDizzy();
		if(vectors.x>1)
			vectors.x-=0.5;
		else if(vectors.x<-1)
			vectors.x+=0.5;
		else
			vectors.x=0;
		}
	else
		{
		int mx, my;
		SDL_GetMouseState(&mx, &my);
		ang=atan2(my-(int)y, (int)x-mx);
		/*float cang=atan2(my-(int)y, (int)x-mx)*180/3.14+180;			// Dorobic porownanie z aktualnym katem i powolne odwracanie
		if(abs(ang-cang)>180)											// Buahaha, naiwniak x;
			ang++;
		else if(ang!=cang)
			ang--;
		anim=(int)abs(ang / * *180/3.14+180* /)*32/360%32;*/
		//printf("%d\t\t\r", (int)(ang*180/3.14+180)*32/360%32);
		if(spd<maxSpd)
			spd+=maxSpd/10;
		vectors.x=spd*cos(ang);	// *3.14/180
		vectors.y=spd*sin(ang);	// *3.14/180
		}
	setAnim(((int)(ang*180/3.14+180)*32/360%sprite->getAnimCount())*2+(hp<=0));
	x-=vectors.x;
	y+=vectors.y;
	updateRect(floor(x)-anim->spotx, floor(y)-anim->spoty, anim->w, anim->h);
	}

int Mucha::getCol()
	{
	for(list<Mucha *>::iterator it=muchy.begin(); it!=muchy.end(); it++)
		{
		Mucha *tmp=*it;
		if(tmp==this || dizzy/* || tmp->dizzy*/)
			continue;
		if(Object::getCol(*this, *tmp))
			return 1;
		else
			continue;
		}
	return 0;
	}

void Mucha::setDizzy(int setDizzyTimer)
	{
	dizzy=1;
	if(setDizzyTimer<0)
		dizzyTimer=40+rand()%40;
	else
		dizzyTimer=setDizzyTimer;
	//vectors.x=0;
	//vectors.y=0;
	}

void Mucha::setUnDizzy()
	{
	dizzy=0;
	vectors.x=0;
	vectors.y=0;
	}

bool Mucha::getDizzy()
	{
	return dizzy;
	}

void Mucha::setHp(int nhp)
	{
	if(hp>0 && nhp<=0)
		{
		gkills++;
		PlaySound("flybuzz.wav");
		}
	hp=nhp;
	}

int Mucha::getHp()
	{
	return hp;
	}
