#include "main.h"

Text::Text(int setid, int setx, int sety, Sprite *setsprite, string settext, int setWidth, Uint8 setspace, Uint8 setnewline)
	{
	id=setid;
	x=setx; y=sety;
	if(setsprite!=NULL)
		sprite=setsprite;
	else
		{
		printf("FAIL: Text.Text: Null sprite\n");
		return;
		}
	if(setnewline==0)
		setnewline=sprite->getAnim(0)->h;
	frame=0; fspeed=0; fdelay=0; space=setspace; newline=setnewline; text=settext; width=setWidth; actsign=text.length();
	}

void Text::print()
	{
	//Uint32 czas=SDL_GetTicks();
	unsigned int px=x, py=y;
	for(unsigned int i=0; /*i<actsign && */text[i]; i++)
		{
		if(text[i]=='\n')
			{
			px=x;
			py+=newline;
			}
		else if(text[i]==' ')
			px+=space;
		else if(text[i]=='\t')
			{
			px=(px+1)/(space*4)*(space*4);
			px+=space*4;
			}
		else if(/*(Uint8)(text[i]-' ')<0 || */(Uint8)(text[i]-' ')>=sprite->getAnimCount())
			px+=space;
		else
			{
			//putPix(screen, px, py, color(0, 192, 0));
			sprite->print((Uint8)(text[i]-' '), 0, px, py);
			px+=sprite->getAnim((Uint8)(text[i]-' '))->w+1;
			}
		if(text[i]==' ' && px-x>width)
			{
			px=x;
			py+=newline;
			}
		}
	/*if(actsign>text.length())
		update=0;
	else
		update=1;*/
	//actsign+=1;
	//printf("%u\t\t\r", SDL_GetTicks()-czas);
	}

int Text::getWidth()
	{
	//printf(".");
	unsigned int w=0, tmpw=0;
	for(unsigned int i=0; i<text.length(); i++)		// i<text[i]!? Wtf?
		{
		if(text[i]=='\n')
			tmpw=0;
		else if(text[i]==' ')
			tmpw+=space;
		else if(text[i]=='\t')				// Wez ty patrz jaka funkcje edytujesz, co? Pol godziny siedziales i myslales co jest nie tak w wyswietlaniu x;
			tmpw+=space*4;
		else if(/*(Uint8)(text[i]-' ')<0 || */(Uint8)(text[i]-' ')>=sprite->getAnimCount())
			tmpw+=space;
		else
			tmpw+=sprite->getAnim((Uint8)(text[i]-' '))->w;
		if(tmpw>w)
			w=tmpw;
		if(text[i]==' ' && tmpw>width)
			tmpw=0;
		//printf("%d (%c)\n", tmpw, text[i]);
		}
	//printf("Width: %d\t\r", w);
	return w;
	}

void Text::setText(string newText, bool reset)
	{
	update=1;
	text=newText;
	if(reset)
		actsign=1;
	}
