#include "main.h"

Object::Object(int setid, int setx, int sety, Sprite *setsprite, vect &setGrav, vect &setRes, bool spriteIgnore)
	{
	id=setid;
	x=setx; y=sety;
	if(setsprite!=NULL)
		sprite=setsprite;
	else if(!spriteIgnore)
		{
		printf("FAIL: Object.Object: Null sprite\n");
		delete this;
		return;
		}
	grav=setGrav;
	res=setRes;
	vectors.x=0; vectors.y=0;
	animNum=0; frame=0; fspeed=0; fdelay=0; anim=NULL;
	if(!spriteIgnore)
		setAnim(0);
	}

void Object::move()
	{
	return;
	}

void Object::print()
	{
	fdelay+=(fspeed<=0)?anim->speed:fspeed;
	if(fdelay>100)
		{
		fdelay-=100;
		++frame;
		}
	if(frame>=anim->frames)
		{
		frame=anim->returnto;
		animFinished();
		}
	sprite->print(animNum, frame, floor(x), floor(y));
	return;
	}

void Object::animFinished()
	{
	return;
	}

bool Object::getCol(Object &obj1, Object &obj2)
	{
	if(obj1.x-obj1.anim->spotx+obj1.anim->w>obj2.x-obj2.anim->spotx && obj1.x-obj1.anim->spotx<obj2.x-obj2.anim->spotx+obj2.anim->w &&
		obj1.y-obj1.anim->spoty+obj1.anim->h>obj2.y-obj2.anim->spoty && obj1.y-obj1.anim->spoty<obj2.y-obj2.anim->spoty+obj2.anim->h)
		return 1;
	return 0;
	}

/*void Object::setAnim(Uint8 sAnim)
	{
	if(sAnim>=sprite->getAnimCount())
		sAnim%=sprite->getAnimCount();
	animNum=sAnim;
	anim=sprite->getAnim(sAnim);
	}

void Object::setFrame(Uint8 sFrame)
	{
	frame=sFrame;
	}

void Object::setFspeed(Uint8 sFspeed)
	{
	fspeed=sFspeed;
	}

void Object::setLayer(Uint8 sLayer)
	{
	layer=sLayer;
	}

void Object::setFdelay(Uint8 sDelay)
	{
	fdelay=sDelay;
	}

void Object::setPos(float sx, float sy)
	{
	x=sx;
	y=sy;
	}

void Object::setSprite(Sprite *sSprite)
	{
	sprite=sSprite;
	}

void Object::setGrav(vect sGrav)
	{
	grav=sGrav;
	}

void Object::setRes(vect sRes)
	{
	res=sRes;
	}

void Object::setVectors(vect sVectors)
	{
	vectors=sVectors;
	}

void Object::setMaxVectors(vect sMaxVectors)
	{
	maxVectors=sMaxVectors;
	}

Uint8 Object::getAnimNum()
	{
	return animNum;
	}

Anim* Object::getAnim()
	{
	return anim;
	}

int Object::getAnimCount()
	{
	return sprite->getAnimCount();
	}

Uint8 Object::getFrame()
	{
	return frame;
	}

Uint8 Object::getFspeed()
	{
	return fspeed;
	}

Uint8 Object::getLayer()
	{
	return layer;
	}

Uint8 Object::getFdelay()
	{
	return fdelay;
	}

void Object::getPos(float &sx, float &sy)
	{
	sx=x;
	sy=y;
	}

float Object::getX()
	{
	return x;
	}

float Object::getY()
	{
	return y;
	}

Sprite* Object::getSprite()
	{
	return sprite;
	}

vect Object::getGrav()
	{
	return grav;
	}

vect Object::getRes()
	{
	return res;
	}

vect Object::getVectors()
	{
	return vectors;
	}

vect Object::getMaxVectors()
	{
	return maxVectors;
	}
*/
